include video_io.e

global object
    vc,                                 -- Video information.
    xf, yf,                             -- Conversion factxors.
    ox, oy                              -- Virtual origin within device space.

global procedure set_coords(atom x1, atom y1, atom x2, atom y2)
-- Set the screen coordinates.
    
    vc = video_config()
    -- Compute conversion factors.
    xf = vc[VC_XPIXELS] / (x2 - x1)
    yf = vc[VC_YPIXELS] / (y2 - y1)
    
    -- Compute device position of virtual origin.
    ox = vc[VC_XPIXELS] - (x2 * xf)
    oy = vc[VC_YPIXELS] - (y2 * yf)
end procedure

global function dx(atom vx)
-- Converts an "x" value.
    return floor(xf * vx) + ox
end function

global function dy(atom vy)
-- Converts a "y" value.
    return floor(yf * vy) + oy
end function

global procedure v_coords()
-- Initialize the variables.
    vc = video_config()
    xf = 1
    yf = 1
    ox = 0
    oy = 0
end procedure

v_coords()
